
  CREATE TABLE "JBOARD"."BOARD"
   (  "ID" NUMBER NOT NULL ENABLE,
   "CREATED" TIMESTAMP (6),
   "CREATED_BY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "DESCRIPTION" VARCHAR2(128 BYTE),
   "LOCKED" NUMBER,
   "STATE" VARCHAR2(64 BYTE),
   "TITLE" VARCHAR2(32 BYTE) NOT NULL ENABLE,
    PRIMARY KEY ("ID"),
    CONSTRAINT "UNQ_TITLE" UNIQUE ("TITLE") DEFERRABLE
   );


  CREATE UNIQUE INDEX "JBOARD"."SYS_C005534" ON "JBOARD"."BOARD" ("ID");
  CREATE INDEX "JBOARD"."UNQ_TITLE" ON "JBOARD"."BOARD" ("TITLE");


  CREATE TABLE "JBOARD"."BOARD_CATEGORY"
   (  "BOARD_ID" NUMBER,
      "MCATEGORIES_ID" NUMBER,
      CONSTRAINT "BOARD_CATEGORY_CATEGORY_FK1" FOREIGN KEY ("BOARD_ID")
     REFERENCES "JBOARD"."BOARD" ("ID") ENABLE
   );


  CREATE INDEX "JBOARD"."I_BRD_GRY_BOARD_ID" ON "JBOARD"."BOARD_CATEGORY" ("BOARD_ID");
  CREATE INDEX "JBOARD"."I_BRD_GRY_ELEMENT" ON "JBOARD"."BOARD_CATEGORY" ("MCATEGORIES_ID");


  CREATE TABLE "JBOARD"."BOARD_MPROPERTIES"
   (  "BOARD_ID" NUMBER,
   "KEY0" VARCHAR2(255 BYTE),
   "VALUE" VARCHAR2(255 BYTE)
   );


  CREATE INDEX "JBOARD"."I_BRD_RTS_BOARD_ID" ON "JBOARD"."BOARD_MPROPERTIES" ("BOARD_ID");


  CREATE TABLE "JBOARD"."CATEGORY"
   (  "ID" NUMBER NOT NULL ENABLE,
   "CREATED" TIMESTAMP (6),
   "CREATED_BY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "DESCRIPTION" VARCHAR2(128 BYTE),
   "LOCKED" NUMBER,
   "STATE" VARCHAR2(64 BYTE),
   "TITLE" VARCHAR2(32 BYTE),
    PRIMARY KEY ("ID") ENABLE
   );


  CREATE TABLE "JBOARD"."CATEGORY_FORUM"
   (  "CATEGORY_ID" NUMBER,
   "MFORUMS_ID" NUMBER,
    CONSTRAINT "CATEGORY_FORUM_CATEGORY_FK1" FOREIGN KEY ("MFORUMS_ID")
     REFERENCES "JBOARD"."FORUM" ("ID") ON DELETE CASCADE ENABLE
   );

  CREATE INDEX "JBOARD"."I_CTGRFRM_CATEGORY_ID" ON "JBOARD"."CATEGORY_FORUM" ("CATEGORY_ID");
  CREATE INDEX "JBOARD"."I_CTGRFRM_ELEMENT" ON "JBOARD"."CATEGORY_FORUM" ("MFORUMS_ID");


  CREATE TABLE "JBOARD"."CATEGORY_MPROPERTIES"
   (  "CATEGORY_ID" NUMBER,
   "KEY0" VARCHAR2(255 BYTE),
   "VALUE" VARCHAR2(255 BYTE)
   );


  CREATE INDEX "JBOARD"."I_CTGRRTS_CATEGORY_ID" ON "JBOARD"."CATEGORY_MPROPERTIES" ("CATEGORY_ID");


  CREATE TABLE "JBOARD"."CATEGORY_POST"
   (  "CATEGORY_ID" NUMBER,
   "MDELETEDPOSTS_ID" NUMBER,
   "MPENDINGPOSTS_ID" NUMBER
   );


  CREATE INDEX "JBOARD"."I_CTGRPST_CATEGORY_ID" ON "JBOARD"."CATEGORY_POST" ("CATEGORY_ID");

  CREATE INDEX "JBOARD"."I_CTGRPST_ELEMENT" ON "JBOARD"."CATEGORY_POST" ("MDELETEDPOSTS_ID");

  CREATE INDEX "JBOARD"."I_CTGRPST_ELEMENT1" ON "JBOARD"."CATEGORY_POST" ("MPENDINGPOSTS_ID");


  CREATE TABLE "JBOARD"."EVENT"
   (  "ID" NUMBER NOT NULL ENABLE,
   "CREATED" TIMESTAMP (6),
   "CREATED_BY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "DESCRIPTION" VARCHAR2(128 BYTE),
   "LOCKED" NUMBER,
   "STATE" VARCHAR2(64 BYTE),
   "TITLE" VARCHAR2(32 BYTE),
   "FOR_USER" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "OBJECT_ID" NUMBER,
   "TEXT" VARCHAR2(128 BYTE),
   "TYPE" VARCHAR2(16 BYTE) NOT NULL ENABLE,
    PRIMARY KEY ("ID") ENABLE
   );


  CREATE TABLE "JBOARD"."EVENT_MPROPERTIES"
   (  "EVENT_ID" NUMBER,
   "KEY0" VARCHAR2(255 BYTE),
   "VALUE" VARCHAR2(255 BYTE)
   );


  CREATE INDEX "JBOARD"."I_VNT_RTS_EVENT_ID" ON "JBOARD"."EVENT_MPROPERTIES" ("EVENT_ID");


  CREATE TABLE "JBOARD"."FORUM"
   (  "ID" NUMBER NOT NULL ENABLE,
   "CREATED" TIMESTAMP (6),
   "CREATED_BY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "DESCRIPTION" VARCHAR2(128 BYTE),
   "LOCKED" NUMBER,
   "STATE" VARCHAR2(64 BYTE),
   "TITLE" VARCHAR2(32 BYTE),
   "MLASTTOPICUPDATED" NUMBER,
    PRIMARY KEY ("ID") ENABLE
   );


  CREATE TABLE "JBOARD"."FORUM_MPROPERTIES"
   (  "FORUM_ID" NUMBER,
   "KEY0" VARCHAR2(255 BYTE),
   "VALUE" VARCHAR2(255 BYTE)
   );


  CREATE INDEX "JBOARD"."I_FRM_RTS_FORUM_ID" ON "JBOARD"."FORUM_MPROPERTIES" ("FORUM_ID");


  CREATE TABLE "JBOARD"."FORUM_TOPIC"
   (  "FORUM_ID" NUMBER,
   "MTOPICS_ID" NUMBER,
    CONSTRAINT "FORUM_TOPIC_TOPIC_FK1" FOREIGN KEY ("FORUM_ID")
     REFERENCES "JBOARD"."FORUM" ("ID") ENABLE,
    CONSTRAINT "FORUM_TOPIC_TOPIC_FK2" FOREIGN KEY ("MTOPICS_ID")
     REFERENCES "JBOARD"."TOPIC" ("ID") ON DELETE CASCADE ENABLE
   );


  CREATE INDEX "JBOARD"."I_FRM_TPC_ELEMENT" ON "JBOARD"."FORUM_TOPIC" ("MTOPICS_ID");

  CREATE INDEX "JBOARD"."I_FRM_TPC_FORUM_ID" ON "JBOARD"."FORUM_TOPIC" ("FORUM_ID");


  CREATE TABLE "JBOARD"."MEMBER"
   (  "ID" NUMBER NOT NULL ENABLE,
   "CREATED" TIMESTAMP (6),
   "CREATED_BY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "DESCRIPTION" VARCHAR2(128 BYTE),
   "LOCKED" NUMBER,
   "STATE" VARCHAR2(64 BYTE),
   "TITLE" VARCHAR2(32 BYTE),
   "AVATAR" VARCHAR2(128 BYTE),
   "EMAIL" VARCHAR2(256 BYTE) NOT NULL ENABLE,
   "FIRST_NAME" VARCHAR2(32 BYTE),
   "USR_GRP" VARCHAR2(128 BYTE),
   "LAST_NAME" VARCHAR2(32 BYTE),
   "MIDDLE_NAME" VARCHAR2(32 BYTE),
   "LOGIN_NAME" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "PASSWRD" VARCHAR2(64 BYTE) NOT NULL ENABLE,
   "PHOTO" VARCHAR2(128 BYTE),
   "REG_CODE" VARCHAR2(64 BYTE),
   "SIG" VARCHAR2(256 BYTE),
   "TZONE" VARCHAR2(64 BYTE),
    PRIMARY KEY ("ID") ENABLE,
    CONSTRAINT "UNQ_LOGIN_NAME" UNIQUE ("LOGIN_NAME") DEFERRABLE ENABLE,
    CONSTRAINT "UNQ_EMAIL" UNIQUE ("EMAIL") DEFERRABLE ENABLE
   );


  CREATE UNIQUE INDEX "JBOARD"."SYS_C005552" ON "JBOARD"."MEMBER" ("ID");

  CREATE INDEX "JBOARD"."UNQ_EMAIL" ON "JBOARD"."MEMBER" ("EMAIL");

  CREATE INDEX "JBOARD"."UNQ_LOGIN_NAME" ON "JBOARD"."MEMBER" ("LOGIN_NAME");

  CREATE TABLE "JBOARD"."MEMBER_MEMBER"
   (  "MEMBER_ID" NUMBER,
   "MFRIENDS_ID" NUMBER
   );


  CREATE INDEX "JBOARD"."I_MMBRMBR_ELEMENT" ON "JBOARD"."MEMBER_MEMBER" ("MFRIENDS_ID");

  CREATE INDEX "JBOARD"."I_MMBRMBR_MEMBER_ID" ON "JBOARD"."MEMBER_MEMBER" ("MEMBER_ID");


  CREATE TABLE "JBOARD"."MEMBER_MPROPERTIES"
   (  "MEMBER_ID" NUMBER,
   "KEY0" VARCHAR2(255 BYTE),
   "VALUE" VARCHAR2(255 BYTE)
   );


  CREATE INDEX "JBOARD"."I_MMBRRTS_MEMBER_ID" ON "JBOARD"."MEMBER_MPROPERTIES" ("MEMBER_ID");


  CREATE TABLE "JBOARD"."MESSAGE"
   (  "ID" NUMBER NOT NULL ENABLE,
   "BODY" CLOB NOT NULL ENABLE,
   "CREATED" TIMESTAMP (6),
   "CREATED_BY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
    PRIMARY KEY ("ID")  ENABLE
   )
   LOB ("BODY") STORE AS (
   ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
   NOCACHE LOGGING
   STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
   PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT)) ;


  CREATE TABLE "JBOARD"."META_DATA"
   (  "ID" NUMBER NOT NULL ENABLE,
   "DESCRIPTION" VARCHAR2(128 BYTE),
   "DATA_KEY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "DATA_TYPE" VARCHAR2(16 BYTE) NOT NULL ENABLE,
   "DATA_VALUE" VARCHAR2(256 BYTE),
    PRIMARY KEY ("ID") ENABLE,
    CONSTRAINT "UNQ_TYPEKEY" UNIQUE ("DATA_TYPE", "DATA_KEY") DEFERRABLE  ENABLE
   );


  CREATE UNIQUE INDEX "JBOARD"."SYS_C005562" ON "JBOARD"."META_DATA" ("ID");

  CREATE INDEX "JBOARD"."UNQ_TYPEKEY" ON "JBOARD"."META_DATA" ("TYPE", "KEY");


  CREATE TABLE "JBOARD"."POST"
   (  "ID" NUMBER NOT NULL ENABLE,
   "CREATED" TIMESTAMP (6),
   "CREATED_BY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "DESCRIPTION" VARCHAR2(128 BYTE),
   "LOCKED" NUMBER,
   "STATE" VARCHAR2(64 BYTE),
   "TITLE" VARCHAR2(32 BYTE),
   "BODY_ID" NUMBER,
   "PREVIOUS_ID" NUMBER,
   "VERSION" NUMBER,
    PRIMARY KEY ("ID") ENABLE,
    CONSTRAINT "POST_MESSAGE_FK1" FOREIGN KEY ("BODY_ID")
     REFERENCES "JBOARD"."MESSAGE" ("ID") ON DELETE CASCADE ENABLE
   );


  CREATE TABLE "JBOARD"."POST_MPROPERTIES"
   (  "POST_ID" NUMBER,
   "KEY0" VARCHAR2(255 BYTE),
   "VALUE" VARCHAR2(255 BYTE)
   );


  CREATE INDEX "JBOARD"."I_PST_RTS_POST_ID" ON "JBOARD"."POST_MPROPERTIES" ("POST_ID");


  CREATE TABLE "JBOARD"."TOPIC"
   (  "ID" NUMBER NOT NULL ENABLE,
   "CREATED" TIMESTAMP (6),
   "CREATED_BY" VARCHAR2(32 BYTE) NOT NULL ENABLE,
   "DESCRIPTION" VARCHAR2(128 BYTE),
   "LOCKED" NUMBER,
   "STATE" VARCHAR2(64 BYTE),
   "TITLE" VARCHAR2(32 BYTE),
   "MLASTPOSTAUTHOR" VARCHAR2(255 BYTE),
   "MLASTPOSTDATE" TIMESTAMP (6),
   "MLASTPOSTID" NUMBER,
   "MNUMREPLIES" NUMBER,
    PRIMARY KEY ("ID") ENABLE
   );


  CREATE TABLE "JBOARD"."TOPIC_MPROPERTIES"
   (  "TOPIC_ID" NUMBER,
   "KEY0" VARCHAR2(255 BYTE),
   "VALUE" VARCHAR2(255 BYTE)
   );


  CREATE INDEX "JBOARD"."I_TPC_RTS_TOPIC_ID" ON "JBOARD"."TOPIC_MPROPERTIES" ("TOPIC_ID");


  CREATE TABLE "JBOARD"."TOPIC_POST"
   (  "TOPIC_ID" NUMBER,
   "MPOSTS_ID" NUMBER,
    CONSTRAINT "TOPIC_POST_POST_FK1" FOREIGN KEY ("TOPIC_ID")
     REFERENCES "JBOARD"."TOPIC" ("ID") ENABLE
   );


  CREATE INDEX "JBOARD"."I_TPC_PST_ELEMENT" ON "JBOARD"."TOPIC_POST" ("MPOSTS_ID");

  CREATE INDEX "JBOARD"."I_TPC_PST_TOPIC_ID" ON "JBOARD"."TOPIC_POST" ("TOPIC_ID");

